<?php

namespace InSegment\ApiCore\Models;

use Illuminate\Support\Facades\Schema;
use Illuminate\Database\Schema\Blueprint;

class DeletedTransactionRecord extends SupplementaryTable
{
    const TABLE_CAPACITY = 21290;
    
    /**
     * Fillable attributes
     * 
     * @var array
     */
    protected $fillable = [
        'table',
        'key_name',
        'key'
    ];
    
    /**
     * Run the migrations.
     *
     * @param array $enabledTablesToKeys
     * @return void
     */
    public static function establish(array $enabledTablesToKeys, int $maxRecords)
    {
        Schema::create((new static)->getTable(), function (Blueprint $table) use ($enabledTablesToKeys, $maxRecords) {
            if ($maxRecords <= self::TABLE_CAPACITY) {
                $table->engine = 'MEMORY';
            }
            
            $table->enum('table', array_keys($enabledTablesToKeys));
            $table->enum('key_name', array_unique(array_values($enabledTablesToKeys)));
            $table->string('key');
            $table->index('table');
            $table->primary(['table', 'key_name', 'key'], 'deleted_transaction_records_primary');
        });
    }
}
